var vector = {
    getInputRegister: function(addr, unitID) {
        console.log('getInputRegister', {
            addr: addr,
            unitID: unitID
        });
        return addr;
    },
    getHoldingRegister: function(addr, unitID) {
        console.log('getHoldingRegister', {
            addr: addr,
            unitID: unitID
        });
        return addr + 8000;
    },
    getCoil: function(addr, unitID) {
        console.log('getCoil', {
            addr: addr,
            unitID: unitID
        });
        return (addr % 2) === 0;
    },
    setRegister: function(addr, value, unitID) {
        console.log('setRegister', {
            addr: addr,
            value: value,
            unitID: unitID
        });
        return;
    },
    setCoil: function(addr, value, unitID) {
        console.log('setCoil', {
            addr: addr,
            value: value,
            unitID: unitID
        });
        return;
    }
};

// set the server to answer for modbus requests
var ModbusRTU = require("modbus-serial");
var serverTCP = new ModbusRTU.ServerTCP(vector, {host: '0.0.0.0'});
console.log('ModbusTCP listening on modbus://0.0.0.0:502');

serverTCP.on("socketError", function(err) {
    // Handle socket error if needed, can be ignored
    console.error(err);
});



//// create an empty modbus client
//var ModbusRTU = require("modbus-serial");
//var vector = {
//    getInputRegister: function(addr, unitID) {
//        // Synchronous handling
//        return addr;
//    },
//    getHoldingRegister: function(addr, unitID, callback) {
//        // Asynchronous handling (with callback)
//        setTimeout(function() {
//            // callback = function(err, value)
//            callback(null, addr + 8000);
//        }, 10);
//    },
//    getCoil: function(addr, unitID) {
//        // Asynchronous handling (with Promises, async/await supported)
//        return new Promise(function(resolve) {
//            setTimeout(function() {
//                resolve((addr % 2) === 0);
//            }, 10);
//        });
//    },
//    setRegister: function(addr, value, unitID) {
//        // Asynchronous handling supported also here
//        console.log("set register", addr, value, unitID);
//        return;
//    },
//    setCoil: function(addr, value, unitID) {
//        // Asynchronous handling supported also here
//        console.log("set coil", addr, value, unitID);
//        return;
//    }
//};
//
//// set the server to answer for modbus requests
//console.log("ModbusTCP listening on modbus://0.0.0.0:8502");
//var serverTCP = new ModbusRTU.ServerTCP(vector, { host: "0.0.0.0", port: 8502, debug: true, unitID: 1 });
//
//serverTCP.on("socketError", function(err){
//    // Handle socket error if needed, can be ignored
//    console.error(err);
//});



var win = require('nw.gui').Window.get();
win.showDevTools();

document.onkeyup = function(e) {
    // F1
    if(e.keyCode === 112){
        win.showDevTools();
    }
    // F5
    if(e.keyCode === 116){
        win.reloadDev();
    }
};
